Debian Bug report logs - #624469
Fails to start: failed to bind control socket (address in use)

version graph

Package: udev; Maintainer for udev is Marco d'Itri <md@linux.it>; Source for udev is src:systemd.

Reported by: Tony Houghton <h@realh.co.uk>

Date: Thu, 28 Apr 2011 16:33:09 UTC

Severity: serious

Found in version udev/168-1

Fixed in version udev/169-1

Done: Marco d'Itri <md@linux.it>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Thu, 28 Apr 2011 16:33:12 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tony Houghton <h@realh.co.uk>:
New Bug report received and forwarded. Copy sent to Marco d'Itri <md@linux.it>. (Thu, 28 Apr 2011 16:33:12 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Tony Houghton <h@realh.co.uk>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: udev: Intermittent failure to start. Timestamp conflict?
Date: Thu, 28 Apr 2011 17:32:39 +0100
Package: udev
Version: 168-1
Severity: important


udev frequently fails to start at bootup, and I see these messages on
the console (I was unable to recover many of these from /var/log and had
to write them down):

udevd[87]: error: runtime directory '/run/udev' not writable, for now falling back to '/dev/.udev'
udevd[204]: exec of program 'net.agent' failed
udevd[265]: exec of program 'net.agent' failed
udevd[280]: exec of program 'net.agent' failed
...
Starting the hotplug events dispatcher: udevdudevd[435]: error: runtime directory '/run/udev' not writable, for now falling back to '/dev/.udev'
udevd[435]: bind failed: Address already in use
error binding udev control socket
udevd[435]: error binding udev control socket
failed!

As long as gdm3 is disabled (otherwise it effectively locks the system
because it has no input devices) I can log in and invoke-rc.d udev
manually and then it starts up with no issues at all and I can then
start gdm3 and operate the system normally.

I'm not 100% sure, but I think this is caused by conflicting timestamps.
I dual boot with Windows 7 which doesn't seem to have an option to
disable DST switching any more, so I let it set the hw clock incorrectly
and put UTC=no in /etc/default/rcS in Debian.

However, I noticed that timestamps of early parts of the boot sequence
in the logs were an hour ahead, so /etc/default/rcS doesn't seem to be
taking effect until some point after udev tries to start. But once the
system time is corrected udev seems to be able to start. I tried setting
the hw clock back to UTC and setting UTC=yes and udev started
successfully (although it does still complain about /run and net.agent).

I think udev is too vital to the system to allow it to fail for a reason
like this.

-- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (990, 'unstable'), (500, 'testing'), (500, 'stable'), (1, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.38-2-amd64 (SMP w/4 CPU cores)
Locale: LANG=en_GB.utf8, LC_CTYPE=en_GB.utf8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages udev depends on:
ii  debconf [debconf-2.0]        1.5.38      Debian configuration management sy
ii  libc6                        2.11.2-13   Embedded GNU C Library: Shared lib
ii  libselinux1                  2.0.98-1    SELinux runtime shared libraries
ii  libudev0                     168-1       libudev shared library
ii  libusb-0.1-4                 2:0.1.12-17 userspace USB programming library
ii  lsb-base                     3.2-27      Linux Standard Base 3.2 init scrip
ii  util-linux                   2.17.2-9.1  Miscellaneous system utilities

Versions of packages udev recommends:
ii  pciutils                      1:3.1.7-9  Linux PCI Utilities
ii  usbutils                      1:001-1    Linux USB utilities

udev suggests no packages.

-- Configuration Files:
/etc/modprobe.d/blacklist.conf changed:
blacklist evbug
blacklist usbmouse
blacklist usbkbd
blacklist eepro100
blacklist de4x5
blacklist am53c974
blacklist iTCO_wdt


-- debconf information:
  udev/new_kernel_needed: false
  udev/title/upgrade:
  udev/reboot_needed:
  udev/sysfs_deprecated_incompatibility:




Information forwarded to debian-bugs-dist@lists.debian.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Sat, 07 May 2011 21:36:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to md@Linux.IT (Marco d'Itri):
Extra info received and forwarded to list. Copy sent to Marco d'Itri <md@linux.it>. (Sat, 07 May 2011 21:36:03 GMT) Full text and rfc822 format available.

Message #10 received at 624469@bugs.debian.org (full text, mbox):

From: md@Linux.IT (Marco d'Itri)
To: Tony Houghton <h@realh.co.uk>, 624469@bugs.debian.org
Subject: Re: Bug#624469: udev: Intermittent failure to start. Timestamp conflict?
Date: Sat, 7 May 2011 23:34:07 +0200
[Message part 1 (text/plain, inline)]
On Apr 28, Tony Houghton <h@realh.co.uk> wrote:

> udevd[435]: bind failed: Address already in use
> error binding udev control socket
> udevd[435]: error binding udev control socket
> failed!
I do not know why this happens.
You will need to find out why udevd is failing to start (probably
because there is already an udevd process running, but why?).

Debugging early boot
~~~~~~~~~~~~~~~~~~~~
If the system hangs at boot time or fails to boot properly, it may be
useful to examine in real time what is happening while "udevadm settle"
is running. A simple way to do this is:

* boot the system passing "init=/bin/bash" on the kernel command line
* start a getty on tty2 (or the serial console) with a command like
  "/sbin/getty 38400 tty2 &"
* continue the boot process with "exec /sbin/init single"

The open console can be used to check which processes are running and
what they are waiting for.

> I'm not 100% sure, but I think this is caused by conflicting timestamps.
Not this.

> However, I noticed that timestamps of early parts of the boot sequence
> in the logs were an hour ahead, so /etc/default/rcS doesn't seem to be
> taking effect until some point after udev tries to start. But once the
This is even documented in README.Debian.

-- 
ciao,
Marco
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Sun, 08 May 2011 00:54:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tony Houghton <h@realh.co.uk>:
Extra info received and forwarded to list. Copy sent to Marco d'Itri <md@linux.it>. (Sun, 08 May 2011 00:54:06 GMT) Full text and rfc822 format available.

Message #15 received at 624469@bugs.debian.org (full text, mbox):

From: Tony Houghton <h@realh.co.uk>
To: md@Linux.IT (Marco d'Itri), 624469@bugs.debian.org
Subject: Re: Bug#624469: udev: Intermittent failure to start. Timestamp conflict?
Date: Sun, 8 May 2011 01:30:44 +0100
On Sat, 7 May 2011 23:34:07 +0200
md@Linux.IT (Marco d'Itri) wrote:

> On Apr 28, Tony Houghton <h@realh.co.uk> wrote:
> 
> > udevd[435]: bind failed: Address already in use
> > error binding udev control socket
> > udevd[435]: error binding udev control socket
> > failed!
> I do not know why this happens.
> You will need to find out why udevd is failing to start (probably
> because there is already an udevd process running, but why?).
> 
> Debugging early boot
> ~~~~~~~~~~~~~~~~~~~~
> If the system hangs at boot time or fails to boot properly, it may be
> useful to examine in real time what is happening while "udevadm
> settle" is running. A simple way to do this is:
> 
> * boot the system passing "init=/bin/bash" on the kernel command line
> * start a getty on tty2 (or the serial console) with a command like
>   "/sbin/getty 38400 tty2 &"
> * continue the boot process with "exec /sbin/init single"
> 
> The open console can be used to check which processes are running and
> what they are waiting for.

That won't help, because nothing hangs (unless I let gdm3 start with no
input devices available). udev just fails to start but the boot sequence
continues. By the time I could run a command in another console the boot
sequence would have finished. It's very quick because I have an SSD.

I need some debugging in the start scripts and/or udev itself so that I
can check whether udev really is running when it finds the control
socket already in use. And if it is, why is it trying to start twice and
why doesn't the first instance stay running? I guess it isn't (still)
really running already but the new socket can't be created for some
reason. Beej's socket programming guide says a socket's address isn't
cleared for use for a minute or so unless you use SO_REUSEADDR and I
have experienced this in a server program I was writing. But I'm not
sure whether this only happens if the first program exits without
closing the socket.

> > I'm not 100% sure, but I think this is caused by conflicting
> > timestamps.
> Not this.

Definitely? There are sometimes error messages about timestamps in the
future. Even if this doesn't directly cause udev to fail could it cause
something that udev depends on to fail? Or could it cause the udev
control socket to exist (or at least its address to be reserved) while
udev isn't running?

> > However, I noticed that timestamps of early parts of the boot
> > sequence in the logs were an hour ahead, so /etc/default/rcS
> > doesn't seem to be taking effect until some point after udev tries
> > to start. But once the
> This is even documented in README.Debian.

Which README.Debian?





Information forwarded to debian-bugs-dist@lists.debian.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Sun, 08 May 2011 01:03:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Marco d'Itri <md@Linux.IT>:
Extra info received and forwarded to list. Copy sent to Marco d'Itri <md@linux.it>. (Sun, 08 May 2011 01:03:03 GMT) Full text and rfc822 format available.

Message #20 received at 624469@bugs.debian.org (full text, mbox):

From: Marco d'Itri <md@Linux.IT>
To: Tony Houghton <h@realh.co.uk>, 624469@bugs.debian.org
Subject: Re: Bug#624469: udev: Intermittent failure to start. Timestamp conflict?
Date: Sun, 8 May 2011 03:01:27 +0200
[Message part 1 (text/plain, inline)]
On May 08, Tony Houghton <h@realh.co.uk> wrote:

> That won't help, because nothing hangs (unless I let gdm3 start with no
Again:

> > You will need to find out why udevd is failing to start (probably
> > because there is already an udevd process running, but why?).

If the early getty still does not help then you can manually run the
rcS.d scripts instead of starting init.

> > > I'm not 100% sure, but I think this is caused by conflicting
> > > timestamps.
> > Not this.
> Definitely? There are sometimes error messages about timestamps in the
Yes.

> > This is even documented in README.Debian.
> Which README.Debian?
Your guess.

-- 
ciao,
Marco
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, josh@joshtriplett.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Sun, 08 May 2011 03:57:05 GMT) Full text and rfc822 format available.

Message #23 received at 624469@bugs.debian.org (full text, mbox):

From: Josh Triplett <josh@joshtriplett.org>
To: Debian Bug Tracking System <624469@bugs.debian.org>
Subject: Re: Intermittent failure to start. Timestamp conflict?
Date: Sat, 07 May 2011 20:54:38 -0700
Package: udev
Version: 168-1
Followup-For: Bug #624469

I experience this problem as well.  It definitely has nothing to do with
timestamps; I use UTC, and time doesn't jump forward or backward during
the boot process.

When udev attempts to start during the boot process, it complains that
it can't bind the control socket, and fails to start.  However, if I
manually start it via the init script, it starts just fine.

I'll try invoking the init scripts by hand next.

- Josh Triplett

-- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.38-2-amd64 (SMP w/4 CPU cores)
Locale: LANG=C, LC_CTYPE=C (charmap=ANSI_X3.4-1968)
Shell: /bin/sh linked to /bin/dash

Versions of packages udev depends on:
ii  debconf [debconf-2.0]        1.5.39      Debian configuration management sy
ii  libc6                        2.11.2-11   Embedded GNU C Library: Shared lib
ii  libselinux1                  2.0.98-1+b1 SELinux runtime shared libraries
ii  libudev0                     168-1       libudev shared library
ii  libusb-0.1-4                 2:0.1.12-17 userspace USB programming library
ii  lsb-base                     3.2-27      Linux Standard Base 3.2 init scrip
ii  util-linux                   2.17.2-9.1  Miscellaneous system utilities

Versions of packages udev recommends:
ii  pciutils                      1:3.1.7-9  Linux PCI Utilities
ii  usbutils                      1:001-1    Linux USB utilities

udev suggests no packages.

-- debconf information excluded




Information forwarded to debian-bugs-dist@lists.debian.org, josh@joshtriplett.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Sun, 08 May 2011 04:09:03 GMT) Full text and rfc822 format available.

Message #26 received at 624469@bugs.debian.org (full text, mbox):

From: Josh Triplett <josh@joshtriplett.org>
To: Debian Bug Tracking System <624469@bugs.debian.org>
Subject: Re: Intermittent failure to start.
Date: Sat, 07 May 2011 21:07:08 -0700
Package: udev
Version: 168-1
Followup-For: Bug #624469

retitle 624469 Fails to start: failed to bind control socket (address in use)
thanks

I've just checked, and if I boot the system with init=/bin/sh and then
manually run the first two rcS.d scripts (mountkernfs and udev), udev
starts just fine.  But if I let the system boot normally, udev fails to
start, complaining that it can't bind the control socket (address in
use).

Any chance this represents a conflict with udev from the initramfs?

In case it matters, this system uses LVM-on-crypto for the root
filesystem and swap.  That might change something about the boot
process which triggers this problem.

- Josh Triplett

-- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.38-2-amd64 (SMP w/4 CPU cores)
Locale: LANG=C, LC_CTYPE=C (charmap=ANSI_X3.4-1968)
Shell: /bin/sh linked to /bin/dash

Versions of packages udev depends on:
ii  debconf [debconf-2.0]        1.5.39      Debian configuration management sy
ii  libc6                        2.11.2-11   Embedded GNU C Library: Shared lib
ii  libselinux1                  2.0.98-1+b1 SELinux runtime shared libraries
ii  libudev0                     168-1       libudev shared library
ii  libusb-0.1-4                 2:0.1.12-17 userspace USB programming library
ii  lsb-base                     3.2-27      Linux Standard Base 3.2 init scrip
ii  util-linux                   2.17.2-9.1  Miscellaneous system utilities

Versions of packages udev recommends:
ii  pciutils                      1:3.1.7-9  Linux PCI Utilities
ii  usbutils                      1:001-1    Linux USB utilities

udev suggests no packages.

-- debconf information excluded




Changed Bug title to 'Fails to start: failed to bind control socket (address in use)' from 'udev: Intermittent failure to start. Timestamp conflict?' Request was from Josh Triplett <josh@joshtriplett.org> to control@bugs.debian.org. (Sun, 08 May 2011 04:09:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, josh@joshtriplett.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Sun, 08 May 2011 04:21:04 GMT) Full text and rfc822 format available.

Message #31 received at 624469@bugs.debian.org (full text, mbox):

From: Josh Triplett <josh@joshtriplett.org>
To: Debian Bug Tracking System <624469@bugs.debian.org>
Subject: Re: Fails to start: failed to bind control socket (address in use)
Date: Sat, 07 May 2011 21:16:29 -0700
Package: udev
Version: 168-1
Followup-For: Bug #624469

I just confirmed that this problem seems to come down to timing.  I
booted with init=/bin/sh, waited a bit, and then ran "exec /sbin/init".
The system booted normally, and udev started without any errors.

- Josh Triplett

-- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.38-2-amd64 (SMP w/4 CPU cores)
Locale: LANG=en_US.utf8, LC_CTYPE=en_US.utf8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages udev depends on:
ii  debconf [debconf-2.0]        1.5.39      Debian configuration management sy
ii  libc6                        2.11.2-11   Embedded GNU C Library: Shared lib
ii  libselinux1                  2.0.98-1+b1 SELinux runtime shared libraries
ii  libudev0                     168-1       libudev shared library
ii  libusb-0.1-4                 2:0.1.12-17 userspace USB programming library
ii  lsb-base                     3.2-27      Linux Standard Base 3.2 init scrip
ii  util-linux                   2.17.2-9.1  Miscellaneous system utilities

Versions of packages udev recommends:
ii  pciutils                      1:3.1.7-9  Linux PCI Utilities
ii  usbutils                      1:001-1    Linux USB utilities

udev suggests no packages.

-- debconf information excluded




Severity set to 'serious' from 'important' Request was from Josh Triplett <josh@joshtriplett.org> to control@bugs.debian.org. (Sun, 08 May 2011 05:42:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, josh@joshtriplett.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Sun, 08 May 2011 05:45:04 GMT) Full text and rfc822 format available.

Message #36 received at 624469@bugs.debian.org (full text, mbox):

From: Josh Triplett <josh@joshtriplett.org>
To: Debian Bug Tracking System <624469@bugs.debian.org>
Subject: Re: Intermittent failure to start.
Date: Sat, 07 May 2011 22:42:02 -0700
Package: udev
Version: 168-1
Followup-For: Bug #624469

One more note: this occurred after a fresh install of stable and upgrade
to unstable, with no unusual steps taken.

- Josh Triplett

-- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.38-2-amd64 (SMP w/4 CPU cores)
Locale: LANG=en_US.utf8, LC_CTYPE=en_US.utf8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages udev depends on:
ii  debconf [debconf-2.0]        1.5.39      Debian configuration management sy
ii  libc6                        2.13-2      Embedded GNU C Library: Shared lib
ii  libselinux1                  2.0.98-1+b1 SELinux runtime shared libraries
ii  libudev0                     168-1       libudev shared library
ii  libusb-0.1-4                 2:0.1.12-17 userspace USB programming library
ii  lsb-base                     3.2-27      Linux Standard Base 3.2 init scrip
ii  util-linux                   2.17.2-9.1  Miscellaneous system utilities

Versions of packages udev recommends:
ii  pciutils                      1:3.1.7-9  Linux PCI Utilities
ii  usbutils                      1:001-1    Linux USB utilities

udev suggests no packages.

-- debconf information:
  udev/new_kernel_needed: false
  udev/title/upgrade:
  udev/reboot_needed:
  udev/sysfs_deprecated_incompatibility:




Information forwarded to debian-bugs-dist@lists.debian.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Sun, 08 May 2011 06:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to md@Linux.IT (Marco d'Itri):
Extra info received and forwarded to list. Copy sent to Marco d'Itri <md@linux.it>. (Sun, 08 May 2011 06:27:03 GMT) Full text and rfc822 format available.

Message #41 received at 624469@bugs.debian.org (full text, mbox):

From: md@Linux.IT (Marco d'Itri)
To: Josh Triplett <josh@joshtriplett.org>, 624469@bugs.debian.org
Subject: Re: Bug#624469: Intermittent failure to start.
Date: Sun, 8 May 2011 08:24:51 +0200
[Message part 1 (text/plain, inline)]
On May 08, Josh Triplett <josh@joshtriplett.org> wrote:

> Any chance this represents a conflict with udev from the initramfs?
This is the only explanation, but in this case you should see the old
process with ps.
Try again by immediately running something like "strace -v -s 200 udevd"
at the shell prompt so we can see exactly why it is failing to start.

-- 
ciao,
Marco
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Wed, 11 May 2011 20:33:16 GMT) Full text and rfc822 format available.

Acknowledgement sent to Josh Triplett <josh@joshtriplett.org>:
Extra info received and forwarded to list. Copy sent to Marco d'Itri <md@linux.it>. (Wed, 11 May 2011 20:33:16 GMT) Full text and rfc822 format available.

Message #46 received at 624469@bugs.debian.org (full text, mbox):

From: Josh Triplett <josh@joshtriplett.org>
To: Marco d'Itri <md@Linux.IT>
Cc: 624469@bugs.debian.org
Subject: Re: Bug#624469: Intermittent failure to start.
Date: Wed, 11 May 2011 13:28:47 -0700
[Message part 1 (text/plain, inline)]
On Sun, May 08, 2011 at 08:24:51AM +0200, Marco d'Itri wrote:
> On May 08, Josh Triplett <josh@joshtriplett.org> wrote:
> 
> > Any chance this represents a conflict with udev from the initramfs?
> This is the only explanation, but in this case you should see the old
> process with ps.
> Try again by immediately running something like "strace -v -s 200 udevd"
> at the shell prompt so we can see exactly why it is failing to start.

Done; picture attached.  Key line:

bind(3, {sa_family=AF_FILE, path=@"/org/kernel/udev/udevd"}, 25) = -1 EADDRINUSE
 (Address already in use)

- Josh Triplett
[20110511_002.jpg (image/jpeg, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Wed, 11 May 2011 20:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Marco d'Itri <md@Linux.IT>:
Extra info received and forwarded to list. Copy sent to Marco d'Itri <md@linux.it>. (Wed, 11 May 2011 20:39:03 GMT) Full text and rfc822 format available.

Message #51 received at 624469@bugs.debian.org (full text, mbox):

From: Marco d'Itri <md@Linux.IT>
To: Josh Triplett <josh@joshtriplett.org>
Cc: 624469@bugs.debian.org
Subject: Re: Bug#624469: Intermittent failure to start.
Date: Wed, 11 May 2011 22:35:05 +0200
[Message part 1 (text/plain, inline)]
On May 11, Josh Triplett <josh@joshtriplett.org> wrote:

> bind(3, {sa_family=AF_FILE, path=@"/org/kernel/udev/udevd"}, 25) = -1 EADDRINUSE
>  (Address already in use)
OK, so it looks like that there *is* an udevd process left around by
the initramfs.
Can you confirm this with ps at the first prompt?

-- 
ciao,
Marco
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Thu, 12 May 2011 09:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Marco d'Itri <md@Linux.IT>:
Extra info received and forwarded to list. Copy sent to Marco d'Itri <md@linux.it>. (Thu, 12 May 2011 09:51:07 GMT) Full text and rfc822 format available.

Message #56 received at 624469@bugs.debian.org (full text, mbox):

From: Marco d'Itri <md@Linux.IT>
To: Josh Triplett <josh@joshtriplett.org>
Cc: 624469@bugs.debian.org
Subject: Re: Bug#624469: Intermittent failure to start.
Date: Thu, 12 May 2011 11:46:23 +0200
[Message part 1 (text/plain, inline)]
On May 11, Marco d'Itri <md@Linux.IT> wrote:

> > bind(3, {sa_family=AF_FILE, path=@"/org/kernel/udev/udevd"}, 25) = -1 EADDRINUSE
> >  (Address already in use)
> OK, so it looks like that there *is* an udevd process left around by
> the initramfs.
> Can you confirm this with ps at the first prompt?
If this is true, then please add set -x to init-bottom/udev to
understand why all processes are not being killed.

-- 
ciao,
Marco
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Fri, 13 May 2011 08:48:15 GMT) Full text and rfc822 format available.

Acknowledgement sent to Matthias Dellweg <2500@gmx.de>:
Extra info received and forwarded to list. Copy sent to Marco d'Itri <md@linux.it>. (Fri, 13 May 2011 08:48:15 GMT) Full text and rfc822 format available.

Message #61 received at 624469@bugs.debian.org (full text, mbox):

From: Matthias Dellweg <2500@gmx.de>
To: 624469@bugs.debian.org
Subject: Re: Fails to start: failed to bind control socket (address in use)
Date: Fri, 13 May 2011 10:47:50 +0200
[Message part 1 (text/plain, inline)]
Hi, I have this problem as well, and it seems to be some Heisenbug. When I 
boot up the computer normaly, udev fails with the already bound socket and I 
get no input devices. When I put debug on the kernel command line the problem 
seems to get a statistical component, and whenever I put break=init there it 
boots as it should (after ctrl-d).
So I put 'ps -A x > /dev/.initramfs/ps-Ax.udev' on the very top of 
'/etc/init.t/udev'. Now it seems there are indeed two udevd processes left 
[att1] and udev does not start properly.
But when I do 'ps -A x | grep udev > /dev/.initramfs/ps-Ax.udev' there are no 
processes left and udev just works.

Summing this up I think it is a timing problem. It seems to me that the udevd 
from initramfs is in fact killed, but nobody waits for it to actually die.

For now i do a sleep 1 in /etc/init.d/udev and it seems to work. But I think 
this is not a real solution.

Hope this helps,
 Matthias
[ps-Ax.udev (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Fri, 13 May 2011 16:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to md@Linux.IT (Marco d'Itri):
Extra info received and forwarded to list. Copy sent to Marco d'Itri <md@linux.it>. (Fri, 13 May 2011 16:51:03 GMT) Full text and rfc822 format available.

Message #66 received at 624469@bugs.debian.org (full text, mbox):

From: md@Linux.IT (Marco d'Itri)
To: Matthias Dellweg <2500@gmx.de>, 624469@bugs.debian.org
Subject: Re: Bug#624469: Fails to start: failed to bind control socket (address in use)
Date: Fri, 13 May 2011 18:48:26 +0200
[Message part 1 (text/plain, inline)]
On May 13, Matthias Dellweg <2500@gmx.de> wrote:

> Summing this up I think it is a timing problem. It seems to me that the udevd 
> from initramfs is in fact killed, but nobody waits for it to actually die.
This is true, so it looks like that nowadays udevd is slower to die.
This could be a symptom of udevadm settle not working correctly, which
I think is an interesting theory due to #624010.

I need better code for extra/initramfs.bottom, but I am not sure about
what is available to initramfs scripts.

-- 
ciao,
Marco
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Fri, 13 May 2011 17:21:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to josh@joshtriplett.org:
Extra info received and forwarded to list. Copy sent to Marco d'Itri <md@linux.it>. (Fri, 13 May 2011 17:21:06 GMT) Full text and rfc822 format available.

Message #71 received at 624469@bugs.debian.org (full text, mbox):

From: josh@joshtriplett.org
To: Marco d'Itri <md@Linux.IT>
Cc: 624469@bugs.debian.org
Subject: Re: Bug#624469: Intermittent failure to start.
Date: Fri, 13 May 2011 10:07:34 -0700
On Thu, May 12, 2011 at 11:46:23AM +0200, Marco d'Itri wrote:
> On May 11, Marco d'Itri <md@Linux.IT> wrote:
> 
> > > bind(3, {sa_family=AF_FILE, path=@"/org/kernel/udev/udevd"}, 25) = -1 EADDRINUSE
> > >  (Address already in use)
> > OK, so it looks like that there *is* an udevd process left around by
> > the initramfs.
> > Can you confirm this with ps at the first prompt?
> If this is true, then please add set -x to init-bottom/udev to
> understand why all processes are not being killed.

I confirmed via ps that udevd --daemon remains running, in 'Ds' state.

I booted with break=top, and edited init-bottom/udev to add "set -x",
then exited the shell to continue the initramfs.  The trace showed the
loop over /proc/ directories running, finding process with exe -> /sbin/udevd as PID 284 and
calling "kill" on it, then finding another process with exe -> /sbin/udevd as PID 68 and calling "kill" on that too.  It then reaches the end of the loop, and runs:

udev_root=/dev
[ -e /etc/udev/udev.conf ]
. /etc/udev/udev.conf
udev_log=err
mount -n -o move /dev /root/dev
nuke /dev
ln -s /root/dev /dev

Does udevd normally have multiple processes?

- Josh Triplett




Information forwarded to debian-bugs-dist@lists.debian.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Fri, 13 May 2011 19:48:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Marco d'Itri <md@Linux.IT>:
Extra info received and forwarded to list. Copy sent to Marco d'Itri <md@linux.it>. (Fri, 13 May 2011 19:48:03 GMT) Full text and rfc822 format available.

Message #76 received at 624469@bugs.debian.org (full text, mbox):

From: Marco d'Itri <md@Linux.IT>
To: josh@joshtriplett.org, 624469@bugs.debian.org
Cc: 2500@gmx.de
Subject: Re: Bug#624469: Intermittent failure to start.
Date: Fri, 13 May 2011 21:44:44 +0200
[Message part 1 (text/plain, inline)]
On May 13, josh@joshtriplett.org wrote:

> Does udevd normally have multiple processes?
Yes. It would be useful to determine if the problem is that:
- there is a race between the initial wildcard expansion by the shell
  and further forking by udev, or
- the killed processes do not die quickly enough

-- 
ciao,
Marco
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Fri, 13 May 2011 23:42:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Josh Triplett <josh@joshtriplett.org>:
Extra info received and forwarded to list. Copy sent to Marco d'Itri <md@linux.it>. (Fri, 13 May 2011 23:42:03 GMT) Full text and rfc822 format available.

Message #81 received at 624469@bugs.debian.org (full text, mbox):

From: Josh Triplett <josh@joshtriplett.org>
To: Marco d'Itri <md@Linux.IT>
Cc: 624469@bugs.debian.org, 2500@gmx.de
Subject: Re: Bug#624469: Intermittent failure to start.
Date: Fri, 13 May 2011 16:38:42 -0700
On Fri, May 13, 2011 at 09:44:44PM +0200, Marco d'Itri wrote:
> On May 13, josh@joshtriplett.org wrote:
> 
> > Does udevd normally have multiple processes?
> Yes. It would be useful to determine if the problem is that:
> - there is a race between the initial wildcard expansion by the shell
>   and further forking by udev, or
> - the killed processes do not die quickly enough

I'll compare the PIDs in the trace to the PIDs in the subsequent ps
listing.

- Josh Triplett




Information forwarded to debian-bugs-dist@lists.debian.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Sat, 14 May 2011 01:39:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Marco d'Itri <md@Linux.IT>:
Extra info received and forwarded to list. Copy sent to Marco d'Itri <md@linux.it>. (Sat, 14 May 2011 01:39:04 GMT) Full text and rfc822 format available.

Message #86 received at 624469@bugs.debian.org (full text, mbox):

From: Marco d'Itri <md@Linux.IT>
To: Matthias Dellweg <2500@gmx.de>, 624469@bugs.debian.org
Cc: josh@joshtriplett.org
Subject: Re: Bug#624469: Fails to start: failed to bind control socket (address in use)
Date: Sat, 14 May 2011 03:34:33 +0200
[Message part 1 (text/plain, inline)]
On May 13, Marco d'Itri <md@Linux.IT> wrote:

> I need better code for extra/initramfs.bottom, but I am not sure about
> what is available to initramfs scripts.
I have a better idea: can you try replacing the kill loop with just
"udevadm control --exit"?

-- 
ciao,
Marco
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Sat, 14 May 2011 18:57:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Josh Triplett <josh@joshtriplett.org>:
Extra info received and forwarded to list. Copy sent to Marco d'Itri <md@linux.it>. (Sat, 14 May 2011 18:57:03 GMT) Full text and rfc822 format available.

Message #91 received at 624469@bugs.debian.org (full text, mbox):

From: Josh Triplett <josh@joshtriplett.org>
To: Marco d'Itri <md@Linux.IT>
Cc: Matthias Dellweg <2500@gmx.de>, 624469@bugs.debian.org
Subject: Re: Bug#624469: Fails to start: failed to bind control socket (address in use)
Date: Sat, 14 May 2011 11:53:43 -0700
On Sat, May 14, 2011 at 03:34:33AM +0200, Marco d'Itri wrote:
> On May 13, Marco d'Itri <md@Linux.IT> wrote:
> 
> > I need better code for extra/initramfs.bottom, but I am not sure about
> > what is available to initramfs scripts.
> I have a better idea: can you try replacing the kill loop with just
> "udevadm control --exit"?

That seems to work perfectly.

- Josh Triplett




Information forwarded to debian-bugs-dist@lists.debian.org, Marco d'Itri <md@linux.it>:
Bug#624469; Package udev. (Mon, 16 May 2011 07:36:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Matthias Dellweg <2500@gmx.de>:
Extra info received and forwarded to list. Copy sent to Marco d'Itri <md@linux.it>. (Mon, 16 May 2011 07:36:03 GMT) Full text and rfc822 format available.

Message #96 received at 624469@bugs.debian.org (full text, mbox):

From: Matthias Dellweg <2500@gmx.de>
To: "Marco d'Itri" <md@linux.it>, 624469@bugs.debian.org
Cc: Josh Triplett <josh@joshtriplett.org>
Subject: Re: Bug#624469: Fails to start: failed to bind control socket (address in use)
Date: Mon, 16 May 2011 09:33:07 +0200
Seems to do the trick. And after reading the manpage I am tempted to say that 
is THE right fix here.

Am Samstag, 14. Mai 2011 schrieb Marco d'Itri:
> On May 13, Marco d'Itri <md@Linux.IT> wrote:
> I have a better idea: can you try replacing the kill loop with just
> "udevadm control --exit"?




Reply sent to Marco d'Itri <md@linux.it>:
You have taken responsibility. (Thu, 19 May 2011 21:51:05 GMT) Full text and rfc822 format available.

Notification sent to Tony Houghton <h@realh.co.uk>:
Bug acknowledged by developer. (Thu, 19 May 2011 21:51:06 GMT) Full text and rfc822 format available.

Message #101 received at 624469-close@bugs.debian.org (full text, mbox):

From: Marco d'Itri <md@linux.it>
To: 624469-close@bugs.debian.org
Subject: Bug#624469: fixed in udev 169-1
Date: Thu, 19 May 2011 21:48:17 +0000
Source: udev
Source-Version: 169-1

We believe that the bug you reported is fixed in the latest version of
udev, which is due to be installed in the Debian FTP archive:

gir1.2-gudev-1.0_169-1_i386.deb
  to main/u/udev/gir1.2-gudev-1.0_169-1_i386.deb
libgudev-1.0-0_169-1_i386.deb
  to main/u/udev/libgudev-1.0-0_169-1_i386.deb
libgudev-1.0-dev_169-1_i386.deb
  to main/u/udev/libgudev-1.0-dev_169-1_i386.deb
libudev-dev_169-1_i386.deb
  to main/u/udev/libudev-dev_169-1_i386.deb
libudev0_169-1_i386.deb
  to main/u/udev/libudev0_169-1_i386.deb
udev-gtk-udeb_169-1_i386.udeb
  to main/u/udev/udev-gtk-udeb_169-1_i386.udeb
udev-udeb_169-1_i386.udeb
  to main/u/udev/udev-udeb_169-1_i386.udeb
udev_169-1.debian.tar.gz
  to main/u/udev/udev_169-1.debian.tar.gz
udev_169-1.dsc
  to main/u/udev/udev_169-1.dsc
udev_169-1_i386.deb
  to main/u/udev/udev_169-1_i386.deb
udev_169.orig.tar.bz2
  to main/u/udev/udev_169.orig.tar.bz2



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 624469@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Marco d'Itri <md@linux.it> (supplier of updated udev package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Thu, 19 May 2011 23:14:56 +0200
Source: udev
Binary: udev libudev0 libudev-dev udev-udeb udev-gtk-udeb libgudev-1.0-0 gir1.2-gudev-1.0 libgudev-1.0-dev
Architecture: source i386
Version: 169-1
Distribution: unstable
Urgency: medium
Maintainer: Marco d'Itri <md@linux.it>
Changed-By: Marco d'Itri <md@linux.it>
Description: 
 gir1.2-gudev-1.0 - libgudev-1.0 introspection data
 libgudev-1.0-0 - GObject-based wrapper library for libudev
 libgudev-1.0-dev - libgudev-1.0 development files
 libudev-dev - libudev development files
 libudev0   - libudev shared library
 udev       - /dev/ and hotplug management daemon
 udev-gtk-udeb - libudev shared library (udeb)
 udev-udeb  - /dev/ and hotplug management daemon (udeb)
Closes: 624010 624469 626873
Changes: 
 udev (169-1) unstable; urgency=medium
 .
   * New upstream release. Fixes:
     + udevadm settle being unreliable at early boot time. (Closes: #624010)
   * Use "udevadm control --exit" in the initramfs instead of manually
     killing each udevd process. (Closes: #624469)
   * Init script: clean up the initramfs udev database in the even when
     it is in /run/. (Closes: #626873)
Checksums-Sha1: 
 4a7f238706702c1efe67435f2c65fbd548c04b32 1493 udev_169-1.dsc
 6bc5f222802334d3c9e9edc408768a8509cfd2c5 597420 udev_169.orig.tar.bz2
 eaa982e58354757469fe1a485aa358bbb5d5db73 88796 udev_169-1.debian.tar.gz
 aa7dfabedae2229d0f7ba134a7b9c505a1099e03 475138 udev_169-1_i386.deb
 76f2b410d87772be88850b202b81a864910cf269 125552 libudev0_169-1_i386.deb
 88bf23ebc88c4a7a41c1d9fee3dd1307f0ba193a 59918 libudev-dev_169-1_i386.deb
 cc18acf9daf92491a320fb9f673b5c4e0be44925 184300 udev-udeb_169-1_i386.udeb
 ace60f0b85538e49403ac0b2b4209735f9a85238 37990 udev-gtk-udeb_169-1_i386.udeb
 7a199e044b8f247ffc09ee22b36aa82151328d0c 108324 libgudev-1.0-0_169-1_i386.deb
 942f0d8424cf2edbd1c72518af1c0b35c5df2e1c 2990 gir1.2-gudev-1.0_169-1_i386.deb
 aa90ab71c30e78e82745d243be12dc5ea98b6134 45352 libgudev-1.0-dev_169-1_i386.deb
Checksums-Sha256: 
 5bd0d4293d60ff95387598c5748fc4b2399cafc2f2c15e85b074d0f7ff685557 1493 udev_169-1.dsc
 4f4206b164972627c5972fabf633210eb9ca8e9e559bbad7fd4d0ab95f2c4e99 597420 udev_169.orig.tar.bz2
 330d93cd2a09e29db9ed5b83bf7c18c4445d6ae2b59fe259b71d370215a01b6a 88796 udev_169-1.debian.tar.gz
 dda1cf7068334e77a820e008416a2f61220d8c09ce34e1ff4c030854311062e2 475138 udev_169-1_i386.deb
 705ae5775c1895c54198aa203bff19107723bd238abb879224a3db12f232ede5 125552 libudev0_169-1_i386.deb
 ba6a7fb21b7ec9e51c9c48d277ab3140f523a3b335056624f17b583bf1c78310 59918 libudev-dev_169-1_i386.deb
 56226df4e4be81c5445a4b65f0648febd4028e592341673fdb7b847aebadc621 184300 udev-udeb_169-1_i386.udeb
 7fa8afdbce93e8bb7a6c8d5938647f868a247fd5250b5e85935ca05ce0aeae44 37990 udev-gtk-udeb_169-1_i386.udeb
 43447aec5b20effd979cc19916929c18b8f7b96553d09f8c1595162f8385bd0a 108324 libgudev-1.0-0_169-1_i386.deb
 7ded44a8d7053078db28ff63cbce1271aa1b784c0c1f33986d895d7b1a518ba5 2990 gir1.2-gudev-1.0_169-1_i386.deb
 7164a746c06c0be17c5fd8359333d469344aa7231ecab42156be1acbb670b7ef 45352 libgudev-1.0-dev_169-1_i386.deb
Files: 
 9eed471cbeb0ca158179e5f164a795aa 1493 admin important udev_169-1.dsc
 967c66e6b8e29d7cfc98326c5b00454d 597420 admin important udev_169.orig.tar.bz2
 55cfc6507117773c9a48325c5c5645e5 88796 admin important udev_169-1.debian.tar.gz
 c050221eecaaeb345a72f83c86bba4f0 475138 admin important udev_169-1_i386.deb
 99550c19b84caf18f0c4e8aa23fffcde 125552 libs important libudev0_169-1_i386.deb
 97818f4e48ef1df70efcdab630a65975 59918 libdevel optional libudev-dev_169-1_i386.deb
 222dd1a12cfd16369ad98410a3c085c2 184300 debian-installer important udev-udeb_169-1_i386.udeb
 4dda1627ccb80ad4a887649287e7184e 37990 debian-installer optional udev-gtk-udeb_169-1_i386.udeb
 55eedab3d17af5a5f33b2654950cafe7 108324 libs optional libgudev-1.0-0_169-1_i386.deb
 0ca5609bc5b278548fa31a1d20cfc9cb 2990 libs optional gir1.2-gudev-1.0_169-1_i386.deb
 fd02c6e26e2ddc744287c7bdde58cfde 45352 libdevel optional libgudev-1.0-dev_169-1_i386.deb
Package-Type: udeb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iEYEARECAAYFAk3VjI8ACgkQFGfw2OHuP7H98gCeLv6fIflTXYCxKR5IuNQKllNL
IoIAn1znctnIOl7VqZSn4B5UyMMph+Sn
=9kwC
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 19 Jun 2011 07:35:07 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 07:36:38 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.